import { getBaseBabelChain, createBabelChain } from "@modern-js/babel-preset-base";
import { getPlugins } from "./plugins";
export * from "@modern-js/babel-preset-base";
var getBabelConfig = function(libPresetOption, syntaxOption) {
    return getBabelChain(libPresetOption, syntaxOption).toJSON();
};
var getBabelChain = function(libPresetOption, syntaxOption) {
    var appDirectory = libPresetOption.appDirectory, jsxTransformRuntime = libPresetOption.jsxTransformRuntime, enableReactPreset = libPresetOption.enableReactPreset, enableTypescriptPreset = libPresetOption.enableTypescriptPreset, lodashOptions = libPresetOption.lodashOptions, styledComponentsOptions = libPresetOption.styledComponentsOptions;
    var syntax = syntaxOption.syntax, type = syntaxOption.type;
    var chain = createBabelChain();
    var baseChain = getBaseBabelChain({
        appDirectory: appDirectory,
        type: type,
        syntax: syntax,
        presets: {
            envOptions: true,
            reactOptions: enableReactPreset,
            typescriptOptions: enableTypescriptPreset ? {
                allowDeclareFields: true,
                allExtensions: true
            } : false
        },
        plugins: {
            transformRuntime: {
                corejs: false,
                // 关闭 corejs
                // for es5 code need helper functions
                helpers: syntaxOption.syntax === "es5"
            },
            lodashOptions: lodashOptions,
            styledComponentsOptions: styledComponentsOptions
        },
        jsxTransformRuntime: jsxTransformRuntime
    });
    var plugins = getPlugins(libPresetOption);
    return chain.merge(baseChain).merge(plugins);
};
export * from "./types";
import { applyUserBabelConfig } from "@modern-js/babel-preset-base";
export { applyUserBabelConfig, getBabelChain, getBabelConfig };
